<html>
<head>
<title>OgreRenderable.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreRenderable.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreRenderable_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Renderable_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Renderable_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderOperation_8h.html">OgreRenderOperation.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreMatrix4_8h.html">OgreMatrix4.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreMaterial_8h.html">OgreMaterial.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgrePlane_8h.html">OgrePlane.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector4_8h.html">OgreVector4.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="OgreException_8h.html">OgreException.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="OgreUserObjectBindings_8h.html">OgreUserObjectBindings.h</a>&quot;</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">namespace </span>Ogre {
<a name="l00044"></a>00044 
<a name="l00062"></a><a class="code" href="classOgre_1_1Renderable.html">00062</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>
<a name="l00063"></a>00063     {
<a name="l00064"></a>00064     <span class="keyword">public</span>:
<a name="l00070"></a><a class="code" href="classOgre_1_1Renderable_1_1RenderSystemData.html">00070</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1Renderable_1_1RenderSystemData.html" title="An internal class that should be used only by a render system for internal use.">RenderSystemData</a> {}; 
<a name="l00071"></a>00071     <span class="keyword">public</span>:
<a name="l00072"></a><a class="code" href="classOgre_1_1Renderable.html#aed186856b59bf967f3188bfa70546957">00072</a>         <a class="code" href="classOgre_1_1Renderable.html#aed186856b59bf967f3188bfa70546957">Renderable</a>() : mPolygonModeOverrideable(true), mUseIdentityProjection(false), mUseIdentityView(false), mRenderSystemData(NULL) {}
<a name="l00074"></a><a class="code" href="classOgre_1_1Renderable.html#ae5a6101851f1e45229f7b4bc20a69815">00074</a>         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>() 
<a name="l00075"></a>00075         {
<a name="l00076"></a>00076             <span class="keywordflow">if</span> (mRenderSystemData)
<a name="l00077"></a>00077             {
<a name="l00078"></a>00078                 <span class="keyword">delete</span> mRenderSystemData;
<a name="l00079"></a>00079                 mRenderSystemData = NULL;
<a name="l00080"></a>00080             }           
<a name="l00081"></a>00081         }
<a name="l00087"></a>00087         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00093"></a><a class="code" href="classOgre_1_1Renderable.html#aafcc80b06f8c74eaac3d35e72ca54842">00093</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* <a class="code" href="classOgre_1_1Renderable.html#aafcc80b06f8c74eaac3d35e72ca54842" title="Retrieves a pointer to the Material Technique this renderable object uses.">getTechnique</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> getMaterial()-&gt;getBestTechnique(0, <span class="keyword">this</span>); }
<a name="l00096"></a>00096         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getRenderOperation(<a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op) = 0;
<a name="l00097"></a>00097 
<a name="l00122"></a><a class="code" href="classOgre_1_1Renderable.html#afcbf4cb36d5911a9d40a40c57e94f23b">00122</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> preRender(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* sm, <a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>* rsys)
<a name="l00123"></a>00123                 { (void)sm; (void)rsys; <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00124"></a>00124 
<a name="l00127"></a><a class="code" href="classOgre_1_1Renderable.html#a77230eea8136b7c296cc0a5db1dba9ee">00127</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> postRender(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* sm, <a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>* rsys)
<a name="l00128"></a>00128                 { (void)sm; (void)rsys; }
<a name="l00129"></a>00129 
<a name="l00142"></a>00142         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* xform) <span class="keyword">const</span> = 0;
<a name="l00143"></a>00143 
<a name="l00152"></a><a class="code" href="classOgre_1_1Renderable.html#ab6ecba3943f56182cddf3b3540afc760">00152</a>         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1Renderable.html#ab6ecba3943f56182cddf3b3540afc760" title="Returns the number of world transform matrices this renderable requires.">getNumWorldTransforms</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00153"></a>00153 
<a name="l00163"></a><a class="code" href="classOgre_1_1Renderable.html#a4136ce4b9d3add5203339327015d872d">00163</a>         <span class="keywordtype">void</span> setUseIdentityProjection(<span class="keywordtype">bool</span> useIdentityProjection)
<a name="l00164"></a>00164         {
<a name="l00165"></a>00165             mUseIdentityProjection = useIdentityProjection;
<a name="l00166"></a>00166         }
<a name="l00167"></a>00167 
<a name="l00177"></a><a class="code" href="classOgre_1_1Renderable.html#a2a8f061a5f322e0dae2fd6946fc2966f">00177</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Renderable.html#a2a8f061a5f322e0dae2fd6946fc2966f" title="Returns whether or not to use an &#39;identity&#39; projection.">getUseIdentityProjection</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseIdentityProjection; }
<a name="l00178"></a>00178 
<a name="l00188"></a><a class="code" href="classOgre_1_1Renderable.html#ae53cff42a16304f582ef83ad3017d614">00188</a>         <span class="keywordtype">void</span> setUseIdentityView(<span class="keywordtype">bool</span> useIdentityView)
<a name="l00189"></a>00189         {
<a name="l00190"></a>00190             mUseIdentityView = useIdentityView;
<a name="l00191"></a>00191         }
<a name="l00192"></a>00192 
<a name="l00202"></a><a class="code" href="classOgre_1_1Renderable.html#a55df8c0a5347d589ee6ef7beaa38806e">00202</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Renderable.html#a55df8c0a5347d589ee6ef7beaa38806e" title="Returns whether or not to use an &#39;identity&#39; view.">getUseIdentityView</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseIdentityView; }
<a name="l00203"></a>00203 
<a name="l00209"></a>00209         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredViewDepth(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam) <span class="keyword">const</span> = 0;
<a name="l00210"></a>00210 
<a name="l00215"></a>00215         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; getLights(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00216"></a>00216 
<a name="l00223"></a><a class="code" href="classOgre_1_1Renderable.html#a1ce8341c18f75ef0b6d818eceea5b2e2">00223</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Renderable.html#a1ce8341c18f75ef0b6d818eceea5b2e2" title="Method which reports whether this renderable would normally cast a shadow.">getCastsShadows</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00224"></a>00224 
<a name="l00240"></a><a class="code" href="classOgre_1_1Renderable.html#a572c0331ef2ec650d56063fdc17435f5">00240</a>         <span class="keywordtype">void</span> setCustomParameter(<span class="keywordtype">size_t</span> index, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; value) 
<a name="l00241"></a>00241         {
<a name="l00242"></a>00242             mCustomParameters[index] = value;
<a name="l00243"></a>00243         }
<a name="l00244"></a>00244 
<a name="l00249"></a><a class="code" href="classOgre_1_1Renderable.html#a0c726a0326e8a7d9e80d030541b6bddf">00249</a>         <span class="keywordtype">void</span> removeCustomParameter(<span class="keywordtype">size_t</span> index)
<a name="l00250"></a>00250         {
<a name="l00251"></a>00251             mCustomParameters.erase(index);
<a name="l00252"></a>00252         }
<a name="l00253"></a>00253 
<a name="l00258"></a><a class="code" href="classOgre_1_1Renderable.html#a1a5dee72d381a14b4af08754b10038ed">00258</a>         <span class="keywordtype">bool</span> hasCustomParameter(<span class="keywordtype">size_t</span> index)<span class="keyword"> const</span>
<a name="l00259"></a>00259 <span class="keyword">        </span>{
<a name="l00260"></a>00260             <span class="keywordflow">return</span> mCustomParameters.find(index) != mCustomParameters.end();
<a name="l00261"></a>00261         }
<a name="l00262"></a>00262 
<a name="l00267"></a><a class="code" href="classOgre_1_1Renderable.html#a7f5bd1dc9046cb31307ac53914c82fc9">00267</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; getCustomParameter(<span class="keywordtype">size_t</span> index)<span class="keyword"> const</span>
<a name="l00268"></a>00268 <span class="keyword">        </span>{
<a name="l00269"></a>00269             CustomParameterMap::const_iterator i = mCustomParameters.find(index);
<a name="l00270"></a>00270             <span class="keywordflow">if</span> (i != mCustomParameters.end())
<a name="l00271"></a>00271             {
<a name="l00272"></a>00272                 <span class="keywordflow">return</span> i-&gt;second;
<a name="l00273"></a>00273             }
<a name="l00274"></a>00274             <span class="keywordflow">else</span>
<a name="l00275"></a>00275             {
<a name="l00276"></a>00276                 OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9f57f8f4aefb7fae5fcd69fe155e7003">Exception::ERR_ITEM_NOT_FOUND</a>, 
<a name="l00277"></a>00277                     <span class="stringliteral">&quot;Parameter at the given index was not found.&quot;</span>,
<a name="l00278"></a>00278                     <span class="stringliteral">&quot;Renderable::getCustomParameter&quot;</span>);
<a name="l00279"></a>00279             }
<a name="l00280"></a>00280         }
<a name="l00281"></a>00281 
<a name="l00306"></a><a class="code" href="classOgre_1_1Renderable.html#a42f520f7ba1c57e10130b81ed444affe">00306</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateCustomGpuParameter(
<a name="l00307"></a>00307             <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html" title="Structure recording the use of an automatic parameter.">GpuProgramParameters::AutoConstantEntry</a>&amp; constantEntry,
<a name="l00308"></a>00308             <a class="code" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>* params)<span class="keyword"> const</span>
<a name="l00309"></a>00309 <span class="keyword">        </span>{
<a name="l00310"></a>00310             CustomParameterMap::const_iterator i = mCustomParameters.find(constantEntry.<a class="code" href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html#ae2c1d1787dfea05c7d03d5651f62d4ae">data</a>);
<a name="l00311"></a>00311             <span class="keywordflow">if</span> (i != mCustomParameters.end())
<a name="l00312"></a>00312             {
<a name="l00313"></a>00313                 params-&gt;<a class="code" href="classOgre_1_1GpuProgramParameters.html#af9e29d2087c860156de6792405b679d4" title="Write a 4-element floating-point parameter to the program directly to the underlying constants buffer...">_writeRawConstant</a>(constantEntry.<a class="code" href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html#ae93ddb6e48d13e9768915de45c9a2c57" title="The target (physical) constant index.">physicalIndex</a>, i-&gt;second, 
<a name="l00314"></a>00314                     constantEntry.<a class="code" href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html#a6cd2d6e06a33f89850e9a77e4d61cc00" title="The number of elements per individual entry in this constant Used in case people used packed elements...">elementCount</a>);
<a name="l00315"></a>00315             }
<a name="l00316"></a>00316         }
<a name="l00317"></a>00317 
<a name="l00323"></a><a class="code" href="classOgre_1_1Renderable.html#a2108dfc322953a7bd429be8b62811e56">00323</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setPolygonModeOverrideable(<span class="keywordtype">bool</span> <span class="keyword">override</span>)
<a name="l00324"></a>00324         {
<a name="l00325"></a>00325             mPolygonModeOverrideable = <span class="keyword">override</span>;
<a name="l00326"></a>00326         }
<a name="l00327"></a>00327 
<a name="l00331"></a><a class="code" href="classOgre_1_1Renderable.html#a723105bef101e2385747f214348984b5">00331</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getPolygonModeOverrideable(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00332"></a>00332 <span class="keyword">        </span>{
<a name="l00333"></a>00333             <span class="keywordflow">return</span> mPolygonModeOverrideable;
<a name="l00334"></a>00334         }
<a name="l00335"></a>00335 
<a name="l00343"></a><a class="code" href="classOgre_1_1Renderable.html#a75d842d22f196a307dec5a068709706b">00343</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Renderable.html#a75d842d22f196a307dec5a068709706b">setUserAny</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; anything) { getUserObjectBindings().setUserAny(anything); }
<a name="l00344"></a>00344 
<a name="l00348"></a><a class="code" href="classOgre_1_1Renderable.html#ab6c834f05d7ad973e22ef726461cfb18">00348</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; <a class="code" href="classOgre_1_1Renderable.html#ab6c834f05d7ad973e22ef726461cfb18">getUserAny</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> getUserObjectBindings().getUserAny(); }
<a name="l00349"></a>00349 
<a name="l00354"></a><a class="code" href="classOgre_1_1Renderable.html#a2ed9a2f3c1decac6286f8af974ce2ffc">00354</a>         <a class="code" href="classOgre_1_1UserObjectBindings.html" title="Class that provide convenient interface to establish a linkage between custom user application object...">UserObjectBindings</a>&amp; <a class="code" href="classOgre_1_1Renderable.html#a2ed9a2f3c1decac6286f8af974ce2ffc" title="Return an instance of user objects binding associated with this class.">getUserObjectBindings</a>() { <span class="keywordflow">return</span> mUserObjectBindings; }
<a name="l00355"></a>00355 
<a name="l00360"></a><a class="code" href="classOgre_1_1Renderable.html#ab323ad1058e8a5b1a9863f5b97d3f2ad">00360</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1UserObjectBindings.html" title="Class that provide convenient interface to establish a linkage between custom user application object...">UserObjectBindings</a>&amp; <a class="code" href="classOgre_1_1Renderable.html#ab323ad1058e8a5b1a9863f5b97d3f2ad" title="Return an instance of user objects binding associated with this class.">getUserObjectBindings</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUserObjectBindings; }
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 
<a name="l00376"></a><a class="code" href="classOgre_1_1Renderable_1_1Visitor.html">00376</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Visitor</a>
<a name="l00377"></a>00377         {
<a name="l00378"></a>00378         <span class="keyword">public</span>:
<a name="l00380"></a><a class="code" href="classOgre_1_1Renderable_1_1Visitor.html#a67b2d4e6dc274102523fde6b20d79ff5">00380</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Renderable_1_1Visitor.html#a67b2d4e6dc274102523fde6b20d79ff5" title="Virtual destructor needed as class has virtual methods.">~Visitor</a>() { }
<a name="l00390"></a>00390             <span class="keyword">virtual</span> <span class="keywordtype">void</span> visit(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> lodIndex, <span class="keywordtype">bool</span> isDebug, 
<a name="l00391"></a>00391                 <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>* pAny = 0) = 0;
<a name="l00392"></a>00392         };
<a name="l00393"></a>00393 
<a name="l00398"></a><a class="code" href="classOgre_1_1Renderable.html#a3da8b6c45259fc0b6ed7b93e3044464c">00398</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Renderable_1_1RenderSystemData.html" title="An internal class that should be used only by a render system for internal use.">RenderSystemData</a> * getRenderSystemData()<span class="keyword"> const </span>
<a name="l00399"></a>00399 <span class="keyword">        </span>{ 
<a name="l00400"></a>00400             <span class="keywordflow">return</span> mRenderSystemData; 
<a name="l00401"></a>00401         }
<a name="l00406"></a><a class="code" href="classOgre_1_1Renderable.html#af52784d34aa33c54516292a341058041">00406</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setRenderSystemData(<a class="code" href="classOgre_1_1Renderable_1_1RenderSystemData.html" title="An internal class that should be used only by a render system for internal use.">RenderSystemData</a> * val)<span class="keyword"> const</span>
<a name="l00407"></a>00407 <span class="keyword">        </span>{ 
<a name="l00408"></a>00408             mRenderSystemData = val; 
<a name="l00409"></a>00409         }
<a name="l00410"></a>00410 
<a name="l00411"></a>00411 
<a name="l00412"></a>00412     <span class="keyword">protected</span>:
<a name="l00413"></a><a class="code" href="classOgre_1_1Renderable.html#a91a88d44c3918d174c1d594f9a4c6736">00413</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;size_t, Vector4&gt;::type</a> <a class="code" href="classOgre_1_1Renderable.html#a91a88d44c3918d174c1d594f9a4c6736">CustomParameterMap</a>;
<a name="l00414"></a><a class="code" href="classOgre_1_1Renderable.html#a7b91506fcf7007e1bf512dade4682731">00414</a>         <a class="code" href="classOgre_1_1Renderable.html#a91a88d44c3918d174c1d594f9a4c6736">CustomParameterMap</a> <a class="code" href="classOgre_1_1Renderable.html#a7b91506fcf7007e1bf512dade4682731">mCustomParameters</a>;
<a name="l00415"></a><a class="code" href="classOgre_1_1Renderable.html#a4b7b701d41bfd85656829261cbcb3495">00415</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Renderable.html#a4b7b701d41bfd85656829261cbcb3495">mPolygonModeOverrideable</a>;
<a name="l00416"></a><a class="code" href="classOgre_1_1Renderable.html#a27ee15aed77a5bf84b2c3f80c060616e">00416</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Renderable.html#a27ee15aed77a5bf84b2c3f80c060616e">mUseIdentityProjection</a>;
<a name="l00417"></a><a class="code" href="classOgre_1_1Renderable.html#a536d8ef571a7a177d94e8a6203bd0b35">00417</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Renderable.html#a536d8ef571a7a177d94e8a6203bd0b35">mUseIdentityView</a>;
<a name="l00418"></a><a class="code" href="classOgre_1_1Renderable.html#aadd56839affa1bd19ac783fe98a08d90">00418</a>         <a class="code" href="classOgre_1_1UserObjectBindings.html" title="Class that provide convenient interface to establish a linkage between custom user application object...">UserObjectBindings</a> <a class="code" href="classOgre_1_1Renderable.html#aadd56839affa1bd19ac783fe98a08d90">mUserObjectBindings</a>;      
<a name="l00419"></a><a class="code" href="classOgre_1_1Renderable.html#a04ee4d7ea24443e1caee62c99add7956">00419</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Renderable_1_1RenderSystemData.html" title="An internal class that should be used only by a render system for internal use.">RenderSystemData</a> * <a class="code" href="classOgre_1_1Renderable.html#a04ee4d7ea24443e1caee62c99add7956" title="User objects binding.">mRenderSystemData</a>;
<a name="l00420"></a>00420     };
<a name="l00421"></a>00421 
<a name="l00426"></a>00426 }
<a name="l00427"></a>00427 
<a name="l00428"></a>00428 <span class="preprocessor">#endif //__Renderable_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
